
export abstract class Node {

    public static readonly TYPE: string;
    public static readonly TYPE_PATTERN: RegExp;
  
    public readonly name: string;
    public readonly data: string;
  
    public constructor(name: string, data: string) {
      this.name = name;
      this.data = data;
    }
  
    public static load(fileName: string, fileData: string): Node {
      throw new Error('You must override the static parse method in specific node implementations');
    }

}